#!/bin/sh
#
# Copyright 2000 by Tivoli Systems, Inc.
# Unpublished Work. All Rights Reserved.
# Licensed Material - Property of Tivoli Systems, Inc.
#


echo
echo "This script will attempt to peform the following"
echo "actions against all osf-axp (Compaq Tru64) gateways:"
echo
echo "1) Stop the gateway"
echo "2) Remove the gateway cache file on the gateway machine"
echo "3) Restart the gateway"
echo
echo "Do you wish to continue? (y/n)       [n]:"
echo
read answer_1
echo
if [ "$answer_1" = "y" ] || [ "$answer_1" = "Y" ] ; then
echo "Continuing. A series of . will be used to indicate progress."
echo
else
echo "Exiting as requested"
echo
exit 1
fi
echo "."
default_pol_num=`wlookup -r TopLevelPolicyRegion -a | awk {'print $2'}`
default_pol_oid=`objcall $default_pol_num _get_members | sed '1!d'`
default_qt=`idlcall $default_pol_oid _get_label`
default_polr=`echo $default_qt | sed 's/"//g'`

wcrttlib wtemplib.$$ $default_polr
if [ $? -eq 0 ]; then
	echo "."
	cat >/tmp/restart.$$ <<EOF
#!/bin/sh
database_mn=\`odadmin | grep Database | awk {'print \$4'}\`
rm \$database_mn/gwdb.bdb
EOF
	wcrttask -t wtemptsk.$$ -l wtemplib.$$ -r super -i osf-axp `hostname` /tmp/restart.$$
	if [ $? -eq 0 ]; then 
		echo "."
	else
		echo "Error creating task.  Task library will be deleted and script"
		echo "will exit."
		wdel @TaskLibrary:wtemplib.$$
		if [ $? -eq 0 ]; then
			echo "Task Library wtemplib.$$ successfully deleted.  Exiting."
			exit 1
		else
			echo "Could not delete Task Library wtemplib.$$.  Please attempt"
			echo "to delete it after script has exited."
			exit 1
		fi
	fi
else
	echo 
	echo "Could not create task library wtemplib.$$ in $default_polr.  Exiting"
	echo
	exit 1
fi

if [ -f $BINDIR/bin/wgateway ]; then
        echo "."
        wgateway | while read a; do
		b=$a
		c=`echo $b | awk {'print $1'}`
		if [ "$c" != "Object" ]; then  
			d=`echo $b | awk {'print $2'}`
			e=`echo $b | awk {'print $3'}`
			f=`echo $c | sed 's/\(.*\)\..*$/\1\.2/'`
			g=`objcall $f get_interp`
			if [ $? -eq 0 ]; then
				if [ "$g" = "osf-axp" ]; then
					wgateway "$d" stop
					if [ $? -eq 0 ]; then
						h=`echo $c | sed 's/\(.*\)\..*$/\1\\\./'`
						i=`wlookup -r ManagedNode -a | grep "$h" | awk {'print $1'}`
						wruntask -t wtemptsk.$$ -l wtemplib.$$ -h $i >> /tmp/tskout.$$ 2>&1
						echo "Task has run on $i.  Please see /tmp/tskout.$$ for all task output"
						wgateway "$d" start
						if [ $? -eq 0 ]; then
							saver=$i
						else
                                                	echo "* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *"
                                                	echo "******************************** E R R O R **********************************"
                                                	echo "                        Could not restart gateway $d."
                                			echo "* This script is designed to exit upon error  so that the error can be      *"
                                			echo "* corrected and the script can be run again.  Correct the error and restart *"
                                			echo "* the script.                                                               *"
                                                	echo "******************************** E R R O R **********************************"
                                                	echo "* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *"
                                                	break
						fi
					else
                                		echo "* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *"
                                		echo "******************************** E R R O R **********************************"
                                		echo "                         Could not stop gateway $d."
		                                echo "* This script is designed to exit upon error  so that the error can be      *"
               		                	echo "* corrected and the script can be run again.  Correct the error and restart *"
                                		echo "* the script.                                                               *"
                                		echo "******************************** E R R O R **********************************"
                                		echo "* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *"
						break
					fi

				else
					echo "$d is not an osf-axp gateway."
				fi
              		else
			        echo "* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *"
        			echo "******************************** E R R O R **********************************"
        			echo "                      Could not contact gateway $d."
                                echo "* This script is designed to exit upon error  so that the error can be      *"
        			echo "* corrected and the script can be run again.  Correct the error and restart *"
        			echo "* the script.                                                               *"
        			echo "******************************** E R R O R **********************************"
        			echo "* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *"
				break
			fi
		fi
        done
else
echo
echo "Could not find the wgateway binary.  Check to see"
echo "if the tivoli environment has been setup correctly."
echo
fi
wdeltask wtemptsk.$$ wtemplib.$$
wdel @TaskLibrary:wtemplib.$$
rm -f /tmp/restart.$$
echo "Exiting..."
